/* 
 * File:   Horloge.c
 * Author: Jelora
 *
 * Created on 21 décembre 2016, 13:27
 */

#pragma config FOSC = HS        // Oscillator Selection bits (HS oscillator)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = OFF      // Power-up Timer Enable bit (PWRT disabled)
#pragma config BOREN = OFF      // Brown-out Reset Enable bit (BOR disabled)
#pragma config LVP = OFF        // Low-Voltage (Single-Supply) In-Circuit Serial Programming Enable bit (RB3 is digital I/O, HV on MCLR must be used for programming)
#pragma config CPD = OFF        // Data EEPROM Memory Code Protection bit (Data EEPROM code protection off)
#pragma config WRT = OFF        // Flash Program Memory Write Enable bits (Write protection off; all program memory may be written to by EECON control)
#pragma config CP = OFF         // Flash Program Memory Code Protection bit (Code protection off)


#include <xc.h>

char heuresDixaines = 0;
char heuresUnites = 0;
char minutesDixaines = 0;
char minutesUnites = 0;
char secondesDixaines = 0;
char secondesUnites = 0;
char affichageHeuresDixaines[3] = {0,0,0};
char affichageHeuresUnites[3] = {0,0,0};
char affichageMinutesDixaines[3] = {0,0,0};
char affichageMinutesUnites[3] = {0,0,0};
char affichageSecondesDixaines[3] = {0,0,0};
char affichageSecondesUnites[3] = {0,0,0};

int frame = 0;
int frameMax = 285;
char niveauMax = 128;

void config();
void affichageHeureAvecEffets();
void gestionTemps();
void gestionBoutonsReglageSecondes();
void gestionBoutonsReglageMinutes();
void gestionBoutonsReglageHeures();

int main(int argc, char** argv) {
    config();
    while(1)
    {
        /*affichageHeureSimple();*/
        affichageHeureAvecEffets();
        gestionTemps();
    }
}

void affichageHeureAvecEffets(){
    // PORTC unités secondes
    // PORTD dixaines secondes
    // PORTC*16 unités minutes
    // PORTD*16 dixaines minutes
    // PORTB unités heures
    // PORTB*16 dixaines heures
    
    // affichage[0] niveau chiffre actuel
    // affichage[0] chiffre actuel
    // affichage[0] chiffre suivant
    
    //PORTC = secondesUnites + minutesUnites*16;
    //PORTD = secondesDixinaies + minutesDixaines*16;
    //PORTB = heuresUnites + heuresDixaines*16;
    PORTC = 0;
    PORTD = 0;
    PORTB = 0;
    char tempPORTC = 0;
    char tempPORTD = 0;
    char tempPORTB = 0;
    
    if ( affichageSecondesUnites[1] != secondesUnites ){
        affichageSecondesUnites[0] = 0;
        affichageSecondesUnites[2] = secondesUnites;
    }
    if ( affichageSecondesDixaines[1] != secondesDixaines ){
        affichageSecondesDixaines[0] = 0;
        affichageSecondesDixaines[2] = secondesDixaines;
    }
    if ( affichageMinutesUnites[1] != minutesUnites ){
        affichageMinutesUnites[0] = 0;
        affichageMinutesUnites[2] = minutesUnites;
    }
    if ( affichageMinutesDixaines[1] != minutesDixaines ){
        affichageMinutesDixaines[0] = 0;
        affichageMinutesDixaines[2] = minutesDixaines;
    }
    if ( affichageHeuresUnites[1] != heuresUnites ){
        affichageHeuresUnites[0] = 0;
        affichageHeuresUnites[2] = heuresUnites;
    }
    if ( affichageHeuresDixaines[1] != heuresDixaines ){
        affichageHeuresDixaines[0] = 0;
        affichageHeuresDixaines[2] = heuresDixaines;
    }
    
    for ( frame = 0 ; frame < frameMax ; frame++ ){
        for ( char niveau = 0 ; niveau < niveauMax ; niveau++ ){
            
            tempPORTC = 0;
            tempPORTD = 0;
            tempPORTB = 0;
            
            if ( niveau > affichageSecondesUnites[0] ){
                tempPORTC = affichageSecondesUnites[1];
            }
            else{
                tempPORTC = affichageSecondesUnites[2];
            }
            if ( niveau > affichageSecondesDixaines[0] ){
                tempPORTD = affichageSecondesDixaines[1];
            }
            else{
                tempPORTD = affichageSecondesDixaines[2];
            }
            if ( niveau > affichageMinutesUnites[0] ){
                tempPORTC += affichageMinutesUnites[1]*16;
            }
            else{
                tempPORTC += affichageMinutesUnites[2]*16;
            }
            if ( niveau > affichageMinutesDixaines[0] ){
                tempPORTD += affichageMinutesDixaines[1]*16;
            }
            else{
                tempPORTD += affichageMinutesDixaines[2]*16;
            }
            if ( niveau > affichageHeuresUnites[0] ){
                tempPORTB = affichageHeuresUnites[1];
            }
            else{
                tempPORTB = affichageHeuresUnites[2];
            }
            if ( niveau > affichageHeuresDixaines[0] ){
                tempPORTB += affichageHeuresDixaines[1]*16;
            }
            else{
                tempPORTB += affichageHeuresDixaines[2]*16;
            }
            
            PORTC = tempPORTC;
            PORTD = tempPORTD;
            PORTB = tempPORTB;
        }
        if ( affichageSecondesUnites[0] < niveauMax ){
            affichageSecondesUnites[0]++;
        }
        else{
            affichageSecondesUnites[1] = affichageSecondesUnites[2];
        }
        if ( affichageSecondesDixaines[0] < niveauMax ){
            affichageSecondesDixaines[0]++;
        }
        else{
            affichageSecondesDixaines[1] = affichageSecondesDixaines[2];
        }
        if ( affichageMinutesUnites[0] < niveauMax ){
            affichageMinutesUnites[0]++;
        }
        else{
            affichageMinutesUnites[1] = affichageMinutesUnites[2];
        }
        if ( affichageMinutesDixaines[0] < niveauMax ){
            affichageMinutesDixaines[0]++;
        }
        else{
            affichageMinutesDixaines[1] = affichageMinutesDixaines[2];
        }
        if ( affichageHeuresUnites[0] < niveauMax ){
            affichageHeuresUnites[0]++;
        }
        else{
            affichageHeuresUnites[1] = affichageHeuresUnites[2];
        }
        if ( affichageHeuresDixaines[0] < niveauMax ){
            affichageHeuresDixaines[0]++;
        }
        else{
            affichageHeuresDixaines[1] = affichageHeuresDixaines[2];
        }
        
        // Gestion des boutons
        // Seulement 2 fois par secondes pour les heures et minutes
        gestionBoutonsReglageSecondes();
        if ( frame == 1 || frame == 143 ){
            gestionBoutonsReglageMinutes();
            gestionBoutonsReglageHeures();
        }
    }
    
    // Précision pour être le plus proche d'une seconde
    for ( char i = 0 ; i < 255 ; i++ ){
    }
    for ( char i = 0 ; i < 95 ; i++ ){
    }
    
}

void gestionBoutonsReglageSecondes(){
    if ( PORTAbits.RA2 ){
        // Reset secondes
        secondesUnites = 0;
        secondesDixaines = 0;
        affichageSecondesUnites[1] = 0;
        affichageSecondesUnites[2] = 0;
        affichageSecondesUnites[0] = niveauMax;
        affichageSecondesDixaines[1] = 0;
        affichageSecondesDixaines[2] = 0;
        affichageSecondesDixaines[0] = niveauMax;
        frame = 0;
    }
}
void gestionBoutonsReglageMinutes(){
    if ( PORTAbits.RA1 ){
        // Ajout d'une minute
        minutesUnites++;
        if ( minutesUnites > 9 ){
            minutesUnites = 0;
            minutesDixaines++;
            if ( minutesDixaines > 5 ){
                minutesDixaines = 0;
            }
        }
        affichageMinutesUnites[1] = minutesUnites;
        affichageMinutesUnites[2] = minutesUnites;
        affichageMinutesUnites[0] = niveauMax;
        affichageMinutesDixaines[1] = minutesDixaines;
        affichageMinutesDixaines[2] = minutesDixaines;
        affichageMinutesDixaines[0] = niveauMax;
    }
}
void gestionBoutonsReglageHeures(){
    if ( PORTAbits.RA0 ){
        // Ajout d'une heure
        heuresUnites++;
        if ( heuresDixaines == 2 ){
            if ( heuresUnites > 3 ){
                heuresUnites = 0;
                heuresDixaines = 0;
            }
        }
        else{
            if ( heuresUnites > 9 ){
                heuresUnites = 0;
                heuresDixaines++;
            }
        }
        affichageHeuresUnites[1] = heuresUnites;
        affichageHeuresUnites[2] = heuresUnites;
        affichageHeuresUnites[0] = niveauMax;
        affichageHeuresDixaines[1] = heuresDixaines;
        affichageHeuresDixaines[2] = heuresDixaines;
        affichageHeuresDixaines[0] = niveauMax;
    }
}

void gestionTemps(){
    if ( !PORTAbits.RA2 ){
        secondesUnites++;
    }
    
    if ( secondesUnites > 9 ){
        secondesUnites = 0;
        secondesDixaines++;
        if ( secondesDixaines > 5 ){
            secondesDixaines = 0;
            if ( !PORTAbits.RA1 ){
                minutesUnites++;
                if ( minutesUnites > 9 ){
                    minutesUnites = 0;
                    minutesDixaines++;
                    if ( minutesDixaines > 5 ){
                        minutesDixaines = 0;
                        if ( !PORTAbits.RA0 ){
                            heuresUnites++;
                            if ( heuresDixaines == 2 ){
                                if ( heuresUnites > 3 ){
                                    heuresUnites = 0;
                                    heuresDixaines = 0;
                                }
                            }
                            else{
                                if ( heuresUnites > 9 ){
                                    heuresUnites = 0;
                                    heuresDixaines++;
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}

void config(){
    ADCON1 = 0b00000110; 
    
    PORTA = 0;
    TRISA = 0b00000111;
    
    PORTB = 0;
    TRISB = 0b00000000;
    
    PORTC = 0;
    TRISC = 0b00000000;
    
    PORTD = 0;
    TRISD = 0b00000000;
    
    PORTE = 0;
    TRISE = 0b00000000;
}

/*void affichageHeureSimple(){
    // PORTC unités secondes
    // PORTD dixaines secondes
    // PORTC*16 unités minutes
    // PORTD*16 dixaines minutes
    // PORTB unités heures
    // PORTB*16 dixaines heures
    
    PORTC = secondesUnites + minutesUnites*16;
    PORTD = secondesDixaines + minutesDixaines*16;
    PORTB = heuresUnites + heuresDixaines*16;
}*/
